:root {
	--max-content-width: 70ch;
	--body-bg-color: black;
	--outline-color: #337AB7;
	--text-color: #FFFFFF;
	--link-color: #539AD7;
	--hline-color: #EEEEEE;
}

* {
	background: transparent;
	border: 0;
	margin: 0;
	outline: 0;
	padding: 0;
	vertical-align: baseline;
	box-sizing: border-box;
	scroll-behavior: smooth;
}

body {
	font-family: -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, "Helvetica Neue", Helvetica, Arial, sans-serif, "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol";
	color: var(--text-color);
	background-image: url("/static/images/background.png");
	background-repeat:   no-repeat;
	background-size: cover;
	background-color: var(--body-bg-color);
	background-position:   center;
	background-attachment:   fixed;
}

.content {
	/*min-height: 100vh;*/
	width: 100%;
	display: grid;
	grid-template-columns:
		[full-full-width-start] 1rem 
		[full-width-start] 1fr 
		[content-start] minmax(
			min(100%, var(--max-content-width)),
			1fr
		)
		[content-end] 1fr
		[full-width-end] 1rem
		[full-full-width-end];
	row-gap: 1rem;
}


body > header,
body > footer,
body > nav,
main > * {
	background-color: black;
	overflow-x: auto;
}

body > header,
body > footer,
body > nav,
.content > * {
	grid-column: content;
	padding: 0.5rem;
	border-radius: 0.25em;
}

.content > .full-width {
	grid-column: full-width;
}

.content > .full-full-width {
	grid-column: full-full-width;
}
body>header{
	background-image: url("/static/images/snow.gif");
}


a {
	color: var(--link-color);
	text-decoration: none;
}
a:focus,
a:hover,
a:focus *,
a:hover *,
input[type=submit]:focus,
input[type=submit]:hover,
input[type=button]:focus,
input[type=button]:hover {
	text-decoration: underline;
}
a.external span::after {
	/* content: '↪'; */
	/* content: '🡕'; */
	content: '⤤';
	/*background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' width='20' height='20.092'%3E%3Cpath d='m12 0 2.561 2.537-6.975 6.976 2.828 2.828 6.988-6.988L20 7.927 19.998 0H12z'/%3E%3Cpath d='M9 4.092v-2H0v18h18v-9h-2v7H2v-14h7z'/%3E%3C/svg%3E");
	background-repeat: no-repeat no-repeat;
	background-position: center center;
	background-size: cover;*/
}
a.external[href^="mailto:"] span::after {
	content: '';
}
a.external[href^="mailto:"] span::before {
	content: '📧';
}




hr {
	height: 0.25rem;
	margin: 0.6rem 0;
	background-color: var(--hline-color);
	border: 0;
	width: 100%;
}

sub {
	vertical-align: -25%;
}
sup {
	vertical-align: 50%;
}



.content .underline {
	text-decoration: underline;
}
.content .smallcaps {
	 font-variant: small-caps;
}

.content p,
.content blockquote,
.content ul,
.content ol,
.content dl,
.content table,
.content pre {
	margin: 0.5em 0 0.5em 0;
}

.content dt {
	font-weight: bold;
}
.content dt::after {
	content: ': '
}

.content dd {
	margin-left: 1em;
	margin-bottom: 0.1em;
}

.content ul,
.content ol {
	padding-left: 2em;
	margin-top: 0em;
}

.content h1 {
	padding-bottom: 0.3em;
	font-size: 2em;
	border-bottom: 0.1em solid var(--hline-color);
	/*-webkit-text-stroke: 0.1rem white;*/
	text-shadow: rgb(0, 0, 0) 0 0 0.5em;
	font-family: monospace;
	color: white;
}

.content h2 {
	padding-bottom: 0.3em;
	font-size: 1.5em;
	border-bottom: 0.1em solid var(--hline-color);
}

.content h1,
.content h2,
.content h3,
.content h4,
.content h5,
.content h6 {
	/*margin-top: 0.8em;*/
	margin-bottom: 0.5em;
	font-weight: 600;
	line-height: 1.25;
}

.content .codeinline,
.content .codeblock {
	/*white-space: pre-wrap;
	overflow-wrap: break-word;
	word-break: keep-all;*/
	overflow: scroll;
}

.content .codeinline {
	background-color: rgba(0, 0, 0, 0.04);
	color: inherit;
	padding: 0.1em 0.4em;
}
.content .codeblock {
	background-color: #272822;
	color: #f8f8f2;
	padding: 0.5em 1em;
}


.content blockquote {
	border-left: 0.25em solid #ddd;
	padding: 0 1em;
	color: #777;
}

.content table,
.content .center {
	max-width: 100%;
	margin-left: auto;
	margin-right: auto;
	/*display: block;*/
}

.content table {
	border-collapse: collapse;
	border-spacing: 0;
}

.content table tr {
	width: 100%;
	/*background-color: #fff;*/
	background-color: #000;
	border: 0.1em solid #ccc;
}

.content table tr:nth-child(2n) {
	background-color: #555;
}

.content table th {
	font-weight: bold;
	text-align: left;
}

.content table th,
.content table td {
	padding: 0.4em 0.9em;
	border: 0.1em solid #ddd;
}
.content table .align_left    { text-align: start; }
.content table .align_right   { text-align: end; }
.content table .align_center  { text-align: center; }
.content table .align_default { text-align: start; }

span.username[data-username-set="False"] {
	color: grey;
}



.leaderboard td[data-solved="True"] {
	background-color: rgba(39, 174, 96,0.8);
}
.leaderboard td[data-solved="True"][data-first="True"] {
	background-color: rgba(28, 130, 71, 0.8);
}
.leaderboard td[data-solved="True"][data-first="True"]::after {
	content: '★';
	color: gold;
 }
.leaderboard tr[data-iscurrentuser="True"] {
	background-color: rgba(39, 96, 174);
}
.leaderboard tr[data-iscurrentuser="True"]:nth-child(2n) {
	background-color: rgba(39, 96, 174);
}
.leaderboard tr.spacer {
	height: 0.3em;
}
.leaderboard th {
	text-align: center;
}
.leaderboard thead tr {
	background-color: var(--body-bg-color);

}
.leaderboard > tfoot > tr.leaderboard__numsolved {
	background-color: #3f87a6;
}



.submissions .submissions__row[data-status="CORRECT"] .submissions__status {
	background-color: #3f8a5e;
}
.submissions .submissions__row[data-status="INCORRECT"] .submissions__status {
	background-color: #953c3c;
}
.submissions .submissions__row[data-status="PENDING"] .submissions__status {
	background-color: #3d52a6;
}
.submissions .submissions__row[data-status="INVALID"] .submissions__status {
	background-color: red;
}


.groupcolor {
	border-radius: 0.5em;
	padding-left: 0.2em;
	padding-right: 0.2em;
	background-color: var(--groupcolor, #000000);
	display: inline-block;
}

h3 > .groupcolor{
	padding: 0.5em;
}


.selectgroup {
	margin-left: 0.05em;
	margin-right: 0.05em;
	color: white;
}

span.username {
	display: inline-block;
	white-space: nowrap;
}

span.username__raw {
	display: inline-flex;
	/*word-wrap: break-word;
	text-overflow: ellipsis;
	white-space: nowrap;*/
	overflow-x: auto;
	max-width: 25ch;
}

.flex {
	display: flex;
	justify-content: space-between;
}

.flex > * {
	padding-left: 0.5em;
	padding-right: 0.5em;
}


.info, .success, .warning, .danger, .alert {
	padding:1em;
	margin-top: 0.4em;
	margin-bottom: 0.4em;
	border:0.1em solid transparent;
	border-radius:0.25em;
	/*padding:15px;
	margin-bottom:20px;
	border:1px solid transparent;
	border-radius:4px;*/
}

.info a,
.success a,
.warning a,
.danger a,
.alert a{
	text-decoration: underline;
}

.info a:focus,
.success a:focus,
.warning a:focus,
.danger a:focus,
.alert a:focus,
.info a:hover,
.success a:hover,
.warning a:hover,
.danger a:hover,
.alert a:hover {
	background-color: var(--body-bg-color);
}

.info    h4 { margin-top:0; color:inherit; }
.success h4 { margin-top:0; color:inherit; }
.warning h4 { margin-top:0; color:inherit; }
.danger  h4 { margin-top:0; color:inherit; }
.alert   h4 { margin-top:0; color:inherit; }

.alert .alert-link {
	font-weight:700;
}

/*
.alert > p, .alert > ul { margin-bottom:0; }
.info      > p, .info      > ul { margin-bottom:0; }
.success   > p, .success   > ul { margin-bottom:0; }
.warning   > p, .warning   > ul { margin-bottom:0; }
.danger    > p, .danger    > ul { margin-bottom:0; }

.alert > p+p { margin-top:0.33em; }
.info     > p+p { margin-top:0.33em; }
.success  > p+p { margin-top:0.33em; }
.warning  > p+p { margin-top:0.33em; }
.danger   > p+p { margin-top:0.33em; }
*/

.alert-dismissable, .alert-dismissible {
	padding-right:2em;
}

.alert-dismissable .close,.alert-dismissible .close{
	position:relative;
	top:-0.1em;
	right:-1.4em;
	color:inherit;
}

.success {
	color:#3c763d;
	background-color:#dff0d8;
	border-color:#d6e9c6;
}

.success hr {
	border-top-color:#c9e2b3;
}


.success .alert-link {
	color:#2b542c;
}

.info {
	color:#31708f;
	background-color:#d9edf7;
	border-color:#bce8f1;
}

.info hr {
	border-top-color:#a6e1ec;
}

.info .alert-link {
	color:#245269;
}

.warning {
	color:#8a6d3b;
	background-color:#fcf8e3;
	border-color:#faebcc;

}

.warning hr {
	border-top-color:#f7e1b5;
}

.warning .alert-link {
	color:#66512c;
}

.danger {
	color:#a94442;
	background-color:#f2dede;
	border-color:#ebccd1;
}

.danger hr {
	border-top-color:#e4b9c0;
}

.danger .alert-link {
	color:#843534;
}





[tabindex]:not([tabindex="-1"]):focus, a:focus, button:focus, input:focus, select:focus:focus, textarea:focus {
	outline-color: var(--outline-color);
	outline-offset: 0.125em;
}


[tabindex]:not([tabindex="-1"]), a, button, input, select, textarea {
	outline: transparent solid 2px;
	outline-offset: 0.25em;
	transition: outline-offset 0.2s linear 0s;
}







@keyframes attention {
	0%, 40%, 80%, 100% {
		transform: scale(1);
	}
	20%, 60% {
		/*transform: scale(1.15);*/
		transform: scale(1.08);
	}
}
.attention {
	animation: attention 1000ms ;
	animation-delay: var(--animation-delay, 0.2s);
	/*font-size: 1.2em;*/
}

.btn {
	margin: 0.3em;
	display: inline-block;
	border-radius: 0.2em;
	line-height: normal;
	white-space: nowrap;
	text-align: center;
	cursor: pointer;
	font-size: 100%;
	padding: 0.3em 0.7em 0.4em;
	color: #fff;
	border: 1px solid rgba(0,0,0,.1);
	background-color: #27ae60;
	text-decoration: none;
	font-weight: 400;
	font-family: Lato,proxima-nova,Helvetica Neue,Arial,sans-serif;
	box-shadow: inset 0 1px 2px -1px hsla(0,0%,100%,.5),inset 0 -2px 0 0 rgba(0,0,0,.1);
	outline-none: false;
	vertical-align: middle;
	*display: inline;
	zoom: 1;
	-webkit-user-drag: none;
	-webkit-user-select: none;
	-moz-user-select: none;
	-ms-user-select: none;
	user-select: none;
	-webkit-transition: all .1s linear;
	-moz-transition: all .1s linear;
	transition: all .1s linear;
}

.btn-primary {
	background-color: #27ae60;
	
	/*
	39  - 44  = -5
	174 - 195 = -21
	96  - 107 = -11
	*/
}
.btn-primary:hover,
.btn-primary:focus {
	background-color: #2cc36b;
}

.btn-secondary {
	background-color: #2760ae;
}
.btn-secondary:hover,
.btn-secondary:focus {
	background-color: #2c6bc3;
}

.btn-tertiary {
	background-color: #ae2760;
}
.btn-tertiary:hover,
.btn-tertiary:focus {
	background-color: #c32c6b;
}

.btn-quaternary {
	background-color: #ae8c27;
}
.btn-quaternary:hover,
.btn-quaternary:focus {
	background-color: #b99732;
}


input[type="text"] {
	/*width: 100%;*/
	margin: 0.5em 0;
	display: inline-block;
	border: 1px solid rgb(204, 204, 204);
	box-shadow: rgb(221, 221, 221) 0px 1px 3px inset;
	border-radius: 0.2em;
	box-sizing: border-box;
	padding: 0.8em 1em;
	color: white;
	caret-color: white;
	background-color: black;
}



